#include "MainWindow.h"
#include <iostream>

MainWindow::MainWindow(QWidget * parent)
:QWidget(parent)
{
	//Creation et positionnement  la ligneedit  et du text brower
	QLayout * l = new QVBoxLayout;
	{
		m_pLineEdit = new QLineEdit(this);
		m_pTexB = new QTextBrowser(this);
		l->addWidget(m_pLineEdit);
		l->addWidget(m_pTexB);
	}
	this->setLayout(l);
	
	//si des donnes arrivent de la sortie standard de l'exe  on va les lire
	connect(&m_Process,SIGNAL(readyReadStandardOutput ()),this,  SLOT(newLigne()));
	//si des donnes arrivent de la sortie d'erreur de l'exe  on va les lire
	connect(&m_Process,SIGNAL(readyReadStandardError ()),this,  SLOT(newLigneErr()));
	//sil'utilisateur appuie sur "entre" on ecrit la commande sur l'entr standard de l'exe
	connect(m_pLineEdit,SIGNAL(returnPressed ()),this,  SLOT(sendCommand()));
}
	
void MainWindow::start(const QString &s_exe)
{
	//met le nom de l'exe en titre de la fenetre
	QFileInfo finfo(s_exe);
	this->setWindowTitle (finfo.fileName ());
	
	//lance l'exe dans un process
	m_Process.start(s_exe);
	//Attend que l'exe soit bien lanc
	if(!m_Process.waitForStarted () )
		std::cout<<"not started"<<std::endl;
}

void MainWindow::sendCommand()
{
	QString command = m_pLineEdit->text();
	//ecrit la commande sur l'entre standard de l'exe
	m_Process.write(command.toAscii () );
	//ajoute un retour a la ligne
	m_Process.putChar ( '\n' );
	
	//affiche en bleu la commande dans le text brower
	m_pTexB->append
					(
						QString("<font color=\"#0000ff\">=>\t")
						+
						command
						+
						QString("</font>")
					);
	m_pLineEdit->clear();
}

void MainWindow::newLigne()
{
	//on selectionne le channel de la sortie standard de l'exe
	m_Process.setReadChannel ( QProcess::StandardOutput );
	//tant que l'on peut lire une ligne
	while (m_Process.canReadLine ())
	{
		//affiche en noire la sortie de l'exe dans le text brower.
		// on elve les caractre \r et \n
		m_pTexB->append  
					(
						QString("    ")
						+
						QString(m_Process.readLine()).remove('\n').remove ('\r')
					);
	}
}

void MainWindow::newLigneErr()
{
	//on selectionne le channel de la sortie d'erreurde l'exe
	m_Process.setReadChannel ( QProcess::StandardError);
	//tant que l'on peut lire une ligne
	while (m_Process.canReadLine ())
	{
	//affiche enrouge la sortie d'erreur de l'exe dans le text brower.
	// on elve les caractre \r et \n
	m_pTexB->append  
					(
						QString("<font color=\"#ff0000\">    ")
						+
						QString(m_Process.readLine()).remove ('\n').remove ('\r')
						+
						QString("</font>")
						
					);
	}
}
    

